;; TO DO LIST


extensions [table]

globals [mearc1-patches mearc2-patches mearc3-patches
mearc4-patches mearc5-patches mearc6-patches mearc7-patches mearc8-patches mearc9-patches
mearc10-patches mearc11-patches mearc12-patches mearc13-patches mearc14-patches mearc15-patches
mearc16-patches mearc17-patches mearc18-patches mearc19-patches mearc20-patches mearc21-patches
mearc22-patches mearc23-patches mearc24-patches mearc25-patches mearc26-patches mearc27-patches
mearc28-patches mearc29-patches mearc30-patches mearc31-patches mearc32-patches mearc33-patches
mearc34-patches mearc35-patches mearc36-patches
all-stimuli-table consonant-table vowel-table tick-list
]

breed [saxons saxon ]
breed [britains britain]
breed [norses norse]
breed [irishes irish]
undirected-link-breed [family-links family-link]
undirected-link-breed [political-links political-link]

turtles-own [neighborhood mearc-member scir-member stimuli-table
capital no-nearby-neighbors? family-group stimuli-concordance age 
in-charge-of-mearc? in-charge-of-scir? interaction-neighbor? old-mearc my-breed-value
]
patches-own[
  scir
  mearc
]
links-own [
]

to setup
  clear-all
  set-default-shape turtles "person"
  set-all-stimuli;; creates lists used to fill habitus
  create-patches
  ;; create breed,  mearc-number, scir-number
  create-saxon-agents  1 1
  create-saxon-agents  2 1
  create-saxon-agents  3 1
  create-saxon-agents  4 2
  create-saxon-agents  5 2
  create-saxon-agents  6 2
  create-saxon-agents  7 3
  create-saxon-agents  8 3
  create-saxon-agents  9 3
  
  create-british-agents 10 4
  create-british-agents 11 4
  create-british-agents 12 4
  create-british-agents 13 5
  create-british-agents 14 5
  create-british-agents 15 5
  create-british-agents 16 6
  create-british-agents 17 6
  create-british-agents 18 6
  
  create-norse-agents 19 7
  create-norse-agents 20 7
  create-norse-agents 21 7
  create-norse-agents 22 8
  create-norse-agents 23 8
  create-norse-agents 24 8
  create-norse-agents 25 9
  create-norse-agents 26 9
  create-norse-agents 27 9
  
  create-irish-agents 28 10
  create-irish-agents 29 10
  create-irish-agents 30 10
  create-irish-agents 31 11
  create-irish-agents 32 11
  create-irish-agents 33 11
  create-irish-agents 34 12
  create-irish-agents 35 12
  create-irish-agents 36 12

  ask turtles [ set in-charge-of-mearc? false set in-charge-of-scir? false set neighborhood von-neighborhood vision 
    set interaction-neighbor? false set old-mearc 0 set no-nearby-neighbors? false set age 0] 
  ask turtles [set-stimuli my-breed-value]
  ask turtles [create-family-links]
  ask turtles [create-political-links]
  ;; number of scirs and maerc per scir
  determine-political-leaders 12 3
  if save-concordance-values [
    set tick-list (list)
    let list-size 20
    let list-multiplier 1
    while [list-multiplier < list-size] [
      set tick-list lput (list-multiplier * (read-from-string every-X-num-of-ticks)) tick-list
      set list-multiplier list-multiplier + 1
    ]
    write-c-values
  ]
  if show-agent-density [ask patches [recolor-patches]]

end

  
to go
  
  ask turtles [birth-agents]
  ask turtles [interact]

  if elite-migration [
    ask turtles [elite-migrate-s-n]
  ]
  
  if global-migration [
    ask turtles [migrate-non-directionally]
  ]
 
  if S-N-migration [
    ask turtles [migrate-s-n]
  ]
  ;;update-plots
  if save-concordance-values [
    if member? ticks tick-list [write-c-values]
  ]
  ask turtles [die-agents]
  if show-agent-density [ask patches [recolor-patches]]
  determine-political-leaders 12 3
  
  ask turtles  [create-political-links]
  tick
end ;; end of GO

to migrate-non-directionally
    let scir-here [scir] of patch-here
      let migration-prob random 100 + 1
      if migration-prob < migration-chance [
        let not-my-scir patches with [scir != scir-here]
        move-to one-of not-my-scir
      ]  
end

 to elite-migrate-s-n
   if capital >= capital-value-for-political-link[
     let scir-here [scir] of patch-here
     if scir-here > 3 and scir-here < 10 [
       let migration-prob random 100 + 1
       if migration-prob < migration-chance [
         let not-my-scir patches with [scir != 4 or scir != 5 or scir != 6 or scir != 7 or scir != 8 or scir != 9  ]
         move-to one-of not-my-scir
       ]
     ]
   ]
 end
 
 to migrate-s-n
    let scir-here [scir] of patch-here
    if scir-here > 3 and scir-here < 10 [
      let migration-prob random 100 + 1
      if migration-prob < migration-chance [
        let not-my-scir patches with [scir != 4 or scir != 5 or scir != 6 or scir != 7 or scir != 8 or scir != 9 ]
        move-to one-of not-my-scir
      ]
    ]
 end
 
 to birth-agents
   if age > 30 [
     if random 100 + 1 < birth-chance [
       let parent-family-links family-link-neighbors
       let parent-political-links political-link-neighbors
       let parent-stimuli table:make
       
       let stimuli-keys table:keys stimuli-table
       let list-number 0
       while [list-number < length stimuli-keys] [
         let this-letter item list-number stimuli-keys
         set this-letter (word this-letter)
         table:put parent-stimuli this-letter (table:get stimuli-table this-letter)
         set list-number list-number + 1  
       ]
       
       let my-bv my-breed-value
         hatch 1 [ move-nearby xcor ycor set stimuli-table parent-stimuli set age 0
         ask parent-family-links [create-family-link-with myself [set color white set hidden? hide-links]]
         ask parent-political-links [create-political-link-with myself [set color yellow set hidden? hide-links]] 
         ]  
       ]
   ]
 end
 
 to die-agents
   set age age + 1
   if age > 30 [ if random 100 + 1 < death-chance [die]]
 end


to interact
  
  let patch-type-here [mearc] of patch-here 
  let mearc-patches patches with [mearc = patch-type-here] 
  ;;evaluate concordance
  ask turtles-on mearc-patches [compare-stimuli-tables stimuli-table]
  let maerc-interaction-partner max-one-of ( other turtles-on mearc-patches ) [stimuli-concordance]
  set neighborhood von-neighborhood (vision)
  let nearby-patch-set patches at-points neighborhood with [mearc = patch-type-here]
  let neighborhood-interaction-partner max-one-of (other turtles-on nearby-patch-set ) [stimuli-concordance]
  
  ;; move towards closest match if that match isn't nearby
  if neighborhood-interaction-partner != maerc-interaction-partner[
    let nearbyAgentX [xcor] of maerc-interaction-partner
    let nearbyAgentY [ycor] of maerc-interaction-partner
    move-nearby nearbyAgentX nearbyAgentY
  ]
  set neighborhood von-neighborhood (vision)
  set nearby-patch-set patches at-points neighborhood with [mearc = patch-type-here]
  set neighborhood-interaction-partner max-one-of (other turtles-on nearby-patch-set ) [stimuli-concordance]
  if neighborhood-interaction-partner = nobody or [stimuli-concordance] of neighborhood-interaction-partner < 51[
    let my-family family-link-neighbors
    ask my-family [compare-stimuli-tables stimuli-table]
    let my-favorite-relative max-one-of my-family [stimuli-concordance]
    ifelse my-favorite-relative = nobody or [stimuli-concordance] of my-favorite-relative < 51 [ ;;* 
      let not-my-mearc patches with [mearc != patch-type-here]
      let civic-connections (turtles-on not-my-mearc) with [old-mearc = patch-type-here]
      if count civic-connections != 0 [
        ask civic-connections [compare-stimuli-tables stimuli-table]
        let best-civic-connection max-one-of other civic-connections [stimuli-concordance]
        ifelse [stimuli-concordance] of best-civic-connection < 66[
          let my-breed-group other [breed] of self
          ask my-breed-group [compare-stimuli-tables stimuli-table]
          let best-breed-choice max-one-of my-breed-group [stimuli-concordance]
          ifelse [stimuli-concordance] of best-breed-choice < 76[
             let my-political-cronies political-link-neighbors
             ask my-political-cronies [compare-stimuli-tables stimuli-table]
             let my-favorite-cronie max-one-of my-political-cronies [stimuli-concordance]
             ifelse my-favorite-cronie = nobody or [stimuli-concordance] of my-favorite-cronie < 51[
               ;;now random migration
               let my-scir [scir] of patch-here
               set old-mearc [mearc] of patch-here
               let not-my-scir patches with [scir != my-scir]
               move-to one-of not-my-scir
             ][
             set old-mearc [mearc] of patch-here
             let nearbyAgentX [xcor] of my-favorite-cronie
             let nearbyAgentY [ycor] of my-favorite-cronie
             move-nearby nearbyAgentX nearbyAgentY
             ]
          ][
            set old-mearc [mearc] of patch-here
            let nearbyAgentX [xcor] of best-breed-choice
            let nearbyAgentY [ycor] of best-breed-choice
            move-nearby nearbyAgentX nearbyAgentY
          ]          
        ][
            set old-mearc [mearc] of patch-here
            let nearbyAgentX [xcor] of best-civic-connection
            let nearbyAgentY [ycor] of best-civic-connection
            move-nearby nearbyAgentX nearbyAgentY
        ]
      ]     
    ][
    set old-mearc [mearc] of patch-here
    let nearbyAgentX [xcor] of my-favorite-relative
    let nearbyAgentY [ycor] of my-favorite-relative
    move-nearby nearbyAgentX nearbyAgentY
    ]
  ]
  set patch-type-here [mearc] of patch-here 
  set mearc-patches patches with [mearc = patch-type-here] 
  ;; if not two agents, random move to best match
  if count other turtles-on nearby-patch-set < 1 
  [ 
    let mearc-count count other turtles-on mearc-patches
    let need-location? true
    while [need-location?][
        move-to one-of mearc-patches
        set neighborhood von-neighborhood (vision)
        set nearby-patch-set patches at-points neighborhood with [mearc = patch-type-here]
        if count other turtles-on nearby-patch-set > 1 [set need-location? false]
        if mearc-count < 2 [set need-location? false die]
    ] 

  ]  
  ;; then asses concordance and behave accordingly
  if count turtles-on nearby-patch-set != 0 
  [
    let interaction-partners other turtles-on nearby-patch-set
    ask interaction-partners [set interaction-neighbor? true]
    ask interaction-partners [compare-stimuli-tables stimuli-table]
    
    while [any? interaction-partners with [interaction-neighbor?]][
      
      let interaction-partner max-one-of (turtles-on nearby-patch-set ) [stimuli-concordance]

      ask interaction-partner [set interaction-neighbor? false]
      let concordance-value [stimuli-concordance] of interaction-partner
      ;; concordance is the amount of stimuli you are willing to share
      ;; capital determines the chance of sharing and the direction  
      let sharing-chance 101   
      if concordance-value > 89 [   

        ifelse capital > [capital] of interaction-partner [;;  determine direction of sharing
          set stimuli-table share-habitus-stimuli stimuli-table [stimuli-table] of interaction-partner sharing-chance
        ][;; other sharing direction
          let table1 [stimuli-table] of interaction-partner 
          let table2 stimuli-table
          ask interaction-partner [set stimuli-table share-habitus-stimuli table1 table2 sharing-chance]
        ]      
      ]
      if concordance-value > 74 and concordance-value < 90 [
        set sharing-chance 75
        ifelse capital > [capital] of interaction-partner [;;  determine direction of sharing
          set stimuli-table share-habitus-stimuli stimuli-table [stimuli-table] of interaction-partner sharing-chance
        ][;; other sharing direction
          let table1 [stimuli-table] of interaction-partner 
          let table2 stimuli-table
          ask interaction-partner [set stimuli-table share-habitus-stimuli table1 table2 sharing-chance]  ]  
      ]
      if concordance-value > 49 and concordance-value < 75 [
          set sharing-chance 50
          ifelse capital > [capital] of interaction-partner [;;  determine direction of sharing
            set stimuli-table share-habitus-stimuli stimuli-table [stimuli-table] of interaction-partner sharing-chance
        ][;; other sharing direction
          let table1 [stimuli-table] of interaction-partner 
          let table2 stimuli-table
          ask interaction-partner [set stimuli-table share-habitus-stimuli table1 table2 sharing-chance]      ]  
      ]
      if concordance-value > 24 and concordance-value < 50 [ 
          set sharing-chance 25
          ifelse capital > [capital] of interaction-partner [;;  determine direction of sharing
            set stimuli-table share-habitus-stimuli stimuli-table [stimuli-table] of interaction-partner sharing-chance
        ][;; other sharing direction
          let table1 [stimuli-table] of interaction-partner 
          let table2 stimuli-table
          ask interaction-partner [set stimuli-table share-habitus-stimuli table1 table2 sharing-chance]      ]  
      ]
      if concordance-value < 25 [
          set sharing-chance 12.5
          ifelse capital > [capital] of interaction-partner [;;  determine direction of sharing
            set stimuli-table share-habitus-stimuli stimuli-table [stimuli-table] of interaction-partner sharing-chance
        ][;; other sharing direction
          let table1 [stimuli-table] of interaction-partner 
          let table2 stimuli-table
          ask interaction-partner [set stimuli-table share-habitus-stimuli table1 table2 sharing-chance]        ]  
      ]     
      
    ] ;; end of while statement 
  ]

  ;;ask turtles [set stimuli-concordance 0]       ;; not necessary since the value is constantly re-evaluated  
end

to-report share-habitus-stimuli [ stimuli-table-high other-stimuli-table share] ;;highest capital entered first
   let keys-list table:keys stimuli-table-high
   let other-keys-list table:keys other-stimuli-table
   let my-table stimuli-table-high
   let other-table other-stimuli-table
   let share-chance share
   foreach [0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19]
          [ ;; put in random number up herefor comparison at all
            if random 100 + 1 <= share-chance [ 
                set other-keys-list  table:keys other-table
                let key1 item ?1 keys-list
                ifelse key1 = "A" or key1 = "E" or key1 = "I" or key1 = "O" or key1 = "U" [
                  ifelse table:has-key? other-table key1[][;; if doesn't have the vowel
                    let random-letter item (random length other-keys-list) other-keys-list
                    table:remove other-table random-letter
                    table:put other-table key1 "v"
                  ]
                ][;; else not a vowel
                ifelse table:has-key? consonant-table key1[
                  ifelse table:has-key? other-table key1[
                    ;; if have same consanant, exchange number
                    let value table:get my-table key1;; no need to remove since the key stays and value changes
                    table:put other-table key1 value
                  ][ ;;if different consonant, half as hard to share, replacing random consonant again
                 if random 100 + 1 < (share-chance / 2) [ 
                    let random-letter item (random length other-keys-list) other-keys-list ;; 
                    let value table:get my-table key1
                    table:remove other-table random-letter
                    table:put other-table key1 value
                 ]              
               ]
                ][;;else not a vowel or consonant, embodied characteristic
                    if random 100 + 1 < (share-chance * (0.25)) [ 
                      ifelse table:has-key? other-table key1[][
                        let random-letter item (random length other-keys-list) other-keys-list
                        let value table:get my-table key1
                        table:remove other-table random-letter
                        table:put other-table key1 value
                      ]
                    ] 
                 
                ]
                ]
            ]
         ]   
  report other-table
end
  
to compare-stimuli-tables [other-table]
  let difference-evaluation 0
  let keys-list table:keys stimuli-table
  foreach [0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19]
  [let key1 item ?1 keys-list
    if table:has-key? other-table key1[
      set difference-evaluation difference-evaluation + 1
    ]
    
  ]
  set stimuli-concordance (difference-evaluation / 20)
end
  
to-report von-neighborhood [n] ;; from moore / von in code examples
  let dim n * 2 + 1
  let result filter [sum map [abs ?] ? <= n]
                n-values (dim ^ 2)
                  [list (? mod dim - n)
                        (floor (? / dim) - n)]
  report result 
end

to recolor-patches
  let patch-type-here mearc
  let patches-nearby patches in-radius 8 with [mearc = patch-type-here]
  let occupied count turtles-on patches-nearby
  let max-scale count patches-nearby  
  set pcolor scale-color pcolor occupied -50 75
end

to create-family-links
  let scir-type-here scir
  let maerc-type-here mearc
  let other-mearcs patches with [scir = scir-type-here and mearc != maerc-type-here]
  ask n-of number-of-outside-family-links turtles-on other-mearcs
  [create-family-link-with myself [set color white set hidden? hide-links]]
  
end

to create-political-links
  let scir-type-here scir
  let maerc-type-here mearc
  let other-mearcs patches with [scir = scir-type-here and mearc != maerc-type-here]
  let other-turtles turtles-on other-mearcs 
  set other-turtles other-turtles with [capital >= capital-value-for-political-link]
  ifelse capital >= capital-value-for-political-link and other-turtles != nobody and count other-turtles > number-of-outside-political-links[
    ask n-of number-of-outside-political-links other-turtles
    [create-political-link-with myself [set color yellow set hidden? hide-links]]
  ][
      if count other-turtles <= number-of-outside-political-links and other-turtles != nobody [
            ask other-turtles [create-political-link-with myself [set color yellow set hidden? hide-links]]
      ]
  ]
end


to move-nearby [xcord ycord]
     let patch-type-here [mearc] of patch-here 
     setxy xcord ycord
     set neighborhood von-neighborhood (vision)
     move-to one-of patches at-points neighborhood with [mearc = patch-type-here]    
end


to create-saxon-agents [mearc-number scir-number ]
   create-saxons (initial-saxons) [
  let my-mearc-patches  patches with [mearc =  mearc-number]
  move-to one-of my-mearc-patches
  set neighborhood von-neighborhood vision
  set color blue set mearc-member mearc-number set scir scir-number set capital random 100 + 1
  set family-group random 4 + 1 set my-breed-value 1 
  while [any? other turtles-here] [
    move-nearby xcor ycor              
  ]

  ]
end


to create-british-agents [mearc-number scir-number ] 
  create-britains (initial-britains) [
  let my-mearc-patches  patches with [mearc =  mearc-number]
  move-to one-of my-mearc-patches
  set neighborhood von-neighborhood vision
  set color black set mearc-member mearc-number set scir scir-number set capital random 100 + 1
  set family-group random 4 + 1 set my-breed-value 2 
  while [any? other turtles-here] [
    move-nearby xcor ycor
  ]

  ] 
end

to create-norse-agents [mearc-number scir-number ] 
  create-norses (initial-norse) [
  let my-mearc-patches  patches with [mearc =  mearc-number]
  move-to one-of my-mearc-patches
  set neighborhood von-neighborhood vision
  set color yellow set mearc-member mearc-number set scir scir-number set capital random 100 + 1
  set family-group random 4 + 1 set my-breed-value 3 
  while [any? other turtles-here] [
    move-nearby xcor ycor
  ]

  ] 
end

to create-irish-agents [mearc-number scir-number ] 
  create-irishes (initial-irish) [
  let my-mearc-patches  patches with [mearc =  mearc-number]
  move-to one-of my-mearc-patches
  set neighborhood von-neighborhood vision
  set color pink set mearc-member mearc-number set scir scir-number set capital random 100 + 1
  set family-group random 4 + 1 set my-breed-value 4 
  while [any? other turtles-here] [
    move-nearby xcor ycor
  ]

  ] 
end

to determine-political-leaders [scir-total mearc-per-shire] 
  let mearc-number 1 
  ask turtles [set in-charge-of-mearc? false]
  
  while [ mearc-number < (mearc-per-shire * scir-total) + 1][
    let mearc-agents turtles-on patches with [mearc = mearc-number]
    if mearc-agents != nobody [
    let leader-agent max-one-of mearc-agents [capital] 
    if leader-agent != nobody [
      ask leader-agent [set in-charge-of-mearc? true]
      ]
    ]
    set mearc-number mearc-number + 1
  ]
  let scir-number 1
  while [scir-number < scir-total + 1][
    let scir-members turtles-on patches with [scir = scir-number]
    if scir-members != nobody [
    let scir-leaders scir-members with [in-charge-of-mearc?] 
    let leader-agent max-one-of scir-leaders [capital] 
    if leader-agent != nobody [
    ask leader-agent [set in-charge-of-scir? true]
    ]
  ]
    set scir-number scir-number + 1
  ]
end




to set-stimuli [breed-value]
  set stimuli-table table:make
  let embodied-table table:make
  ;;embodied letters added
  if breed-value = 1 [
    table:put embodied-table "1" "1!"
    table:put embodied-table "2" "1#"
    table:put embodied-table "3" "1$"
    table:put embodied-table "4" "1%"
    table:put embodied-table "5" "1&"
    table:put embodied-table "6" "1@"
    table:put embodied-table "7" "11"
    table:put embodied-table "8" "12"
    table:put embodied-table "9" "13"
    table:put embodied-table "10" "14"
  ]
  if breed-value = 2 [
    table:put embodied-table "1" "2!"
    table:put embodied-table "2" "2#"
    table:put embodied-table "3" "2$"
    table:put embodied-table "4" "2%"
    table:put embodied-table "5" "2&"
    table:put embodied-table "6" "2@"
    table:put embodied-table "7" "21"
    table:put embodied-table "8" "22"
    table:put embodied-table "9" "23"
    table:put embodied-table "10" "24"
  ]
  if breed-value = 3 [
    table:put embodied-table "1" "3!"
    table:put embodied-table "2" "3#"
    table:put embodied-table "3" "3$"
    table:put embodied-table "4" "3%"
    table:put embodied-table "5" "3&"
    table:put embodied-table "6" "3@"
    table:put embodied-table "7" "31"
    table:put embodied-table "8" "32"
    table:put embodied-table "9" "33"
    table:put embodied-table "10" "34"
  ]
  if breed-value = 4 [
    table:put embodied-table "1" "4!"
    table:put embodied-table "2" "4#"
    table:put embodied-table "3" "4$"
    table:put embodied-table "4" "4%"
    table:put embodied-table "5" "4&"
    table:put embodied-table "6" "4@"
    table:put embodied-table "7" "41"
    table:put embodied-table "8" "42"
    table:put embodied-table "9" "43"
    table:put embodied-table "10" "44"
  ]

  while [table:length stimuli-table < 5] [ 
    let letter-number (random 10) + 1
    set letter-number (word letter-number)
    table:put stimuli-table (table:get embodied-table letter-number) (word breed-value)       
  ]
  
  while [table:length stimuli-table < 20][
    let letter-number (random 25) + 1
    set letter-number (word letter-number)
    table:put stimuli-table (table:get all-stimuli-table letter-number) (word breed-value)
  ]

end

 
to create-patches
  set mearc6-patches patches with [pxcor > 9  and pxcor < 31 and pycor > 0 and pycor < 30]
  ask mearc6-patches [ set pcolor magenta set scir 2 set mearc 6]
  set mearc5-patches patches with [pxcor < 10  and pxcor > -10 and pycor > 0 and pycor < 30]
  ask mearc5-patches [ set pcolor blue set scir 2 set mearc 5] 
  set mearc4-patches patches with [pxcor < -9  and pxcor > -30 and pycor > 0 and pycor < 30]
  ask mearc4-patches [ set pcolor red set scir 2 set mearc 4] 
  set mearc3-patches patches with [pxcor < -29  and pxcor > -50  and pycor > 0 and pycor < 30]
  ask mearc3-patches [ set pcolor green set scir 1 set mearc 3] 
  set mearc2-patches patches with [pxcor < -49  and pxcor > -71  and pycor > 0 and pycor < 30]
  ask mearc2-patches [ set pcolor brown set scir 1 set mearc 2]
  set mearc1-patches patches with [pxcor < -69  and pxcor > -91  and pycor > 0 and pycor < 30]
  ask mearc1-patches [ set pcolor red set scir 1 set mearc 1]  
  set mearc7-patches patches with [pxcor > 30  and pxcor < 51  and pycor > 0 and pycor < 30]
  ask mearc7-patches [ set pcolor sky set scir 3 set mearc 7]
  set mearc8-patches patches with [pxcor > 50 and pxcor < 71 and pycor > 0 and pycor < 30]
  ask mearc8-patches [ set pcolor brown set scir 3 set mearc 8]
  set mearc9-patches patches with [pxcor > 70  and pxcor < 91  and pycor > 0 and pycor < 30]
  ask mearc9-patches [ set pcolor violet set scir 3 set mearc 9]  
  
  set mearc15-patches patches with [pxcor > 9  and pxcor < 31 and pycor < 0 and pycor > -30]
  ask mearc15-patches [ set pcolor green set scir 5 set mearc 15]
  set mearc14-patches patches with [pxcor < 10  and pxcor > -10 and pycor < 0 and pycor > -30]
  ask mearc14-patches [ set pcolor magenta set scir 5 set mearc 14] 
  set mearc13-patches patches with [pxcor < -9  and pxcor > -30 and pycor < 0 and pycor > -30]
  ask mearc13-patches [ set pcolor blue set scir 5 set mearc 13] 
  set mearc12-patches patches with [pxcor < -29  and pxcor > -50  and pycor < 0 and pycor > -30]
  ask mearc12-patches [ set pcolor green set scir 4 set mearc 12] 
  set mearc11-patches patches with [pxcor < -49  and pxcor > -71  and pycor < 0 and pycor > -30]
  ask mearc11-patches [ set pcolor red set scir 4 set mearc 11]
  set mearc10-patches patches with [pxcor < -69  and pxcor > -91  and pycor < 0 and pycor > -30]
  ask mearc10-patches [ set pcolor brown set scir 4 set mearc 10]  
  set mearc16-patches patches with [pxcor > 30  and pxcor < 51  and pycor < 0 and pycor > -30]
  ask mearc16-patches [ set pcolor sky set scir 6 set mearc 16]
  set mearc17-patches patches with [pxcor > 50 and pxcor < 71 and pycor < 0 and pycor > -30]
  ask mearc17-patches [ set pcolor violet set scir 6 set mearc 17]
  set mearc18-patches patches with [pxcor > 70  and pxcor < 91  and pycor < 0 and pycor > -30]
  ask mearc18-patches [ set pcolor brown set scir 6 set mearc 18]  
    
  set mearc24-patches patches with [pxcor > 9  and pxcor < 31 and pycor <=  -30]
  ask mearc24-patches [ set pcolor orange set scir 8 set mearc 24]
  set mearc23-patches patches with [pxcor < 10  and pxcor > -10 and pycor <= -30]
  ask mearc23-patches [ set pcolor blue set scir 8 set mearc 23] 
  set mearc22-patches patches with [pxcor < -9  and pxcor > -30 and pycor <=  -30]
  ask mearc22-patches [ set pcolor brown set scir 8 set mearc 22] 
  set mearc21-patches patches with [pxcor < -29  and pxcor > -50  and pycor <=  -30]
  ask mearc21-patches [ set pcolor turquoise set scir 7 set mearc 21] 
  set mearc20-patches patches with [pxcor < -49  and pxcor > -71  and pycor <=  -30]
  ask mearc20-patches [ set pcolor gray set scir 7 set mearc 20]
  set mearc19-patches patches with [pxcor < -69  and pxcor > -91  and pycor <=  -30]
  ask mearc19-patches [ set pcolor green set scir 7 set mearc 19]  
  set mearc25-patches patches with [pxcor > 30  and pxcor < 51  and pycor <=  -30]
  ask mearc25-patches [ set pcolor magenta set scir 9 set mearc 25]
  set mearc26-patches patches with [pxcor > 50 and pxcor < 71 and pycor <=   -30]
  ask mearc26-patches [ set pcolor blue set scir 9 set mearc 26]
  set mearc27-patches patches with [pxcor > 70  and pxcor < 91  and pycor <= -30]
  ask mearc27-patches [ set pcolor red set scir 9 set mearc 27]  
  
  set mearc33-patches patches with [pxcor > 9  and pxcor < 31 and  pycor >= 30]
  ask mearc33-patches [ set pcolor orange set scir 11 set mearc 33]
  set mearc32-patches patches with [pxcor < 10  and pxcor > -10 and  pycor >= 30]
  ask mearc32-patches [ set pcolor green set scir 11 set mearc 32] 
  set mearc31-patches patches with [pxcor < -9  and pxcor > -30 and  pycor >= 30]
  ask mearc31-patches [ set pcolor gray set scir 11 set mearc 31] 
  set mearc30-patches patches with [pxcor < -29  and pxcor > -50  and  pycor >= 30]
  ask mearc30-patches [ set pcolor blue set scir 10 set mearc 30] 
  set mearc29-patches patches with [pxcor < -49  and pxcor > -71  and  pycor >= 30]
  ask mearc29-patches [ set pcolor magenta set scir 10 set mearc 29]
  set mearc28-patches patches with [pxcor < -69  and pxcor > -91  and  pycor >= 30]
  ask mearc28-patches [ set pcolor green set scir 10 set mearc 28]  
  set mearc34-patches patches with [pxcor > 30  and pxcor < 51  and  pycor >= 30]
  ask mearc34-patches [ set pcolor red set scir 12 set mearc 34]
  set mearc35-patches patches with [pxcor > 50 and pxcor < 71 and  pycor >= 30]
  ask mearc35-patches [ set pcolor orange set scir 12 set mearc 35]
  set mearc36-patches patches with [pxcor > 70  and pxcor < 91  and  pycor >= 30]
  ask mearc36-patches [ set pcolor sky set scir 12 set mearc 36]

end


to set-all-stimuli
  set all-stimuli-table table:make
  table:put all-stimuli-table "1" "A"
  table:put all-stimuli-table "2" "B" 
  table:put all-stimuli-table "3" "C" 
  table:put all-stimuli-table "4" "D" 
  table:put all-stimuli-table "5" "E" 
  table:put all-stimuli-table "6" "F" 
  table:put all-stimuli-table "7" "G" 
  table:put all-stimuli-table "8" "H" 
  table:put all-stimuli-table "9" "I" 
  table:put all-stimuli-table "10" "J" 
  table:put all-stimuli-table "11" "K" 
  table:put all-stimuli-table "12" "L" 
  table:put all-stimuli-table "13" "M" 
  table:put all-stimuli-table "14" "N" 
  table:put all-stimuli-table "15" "O" 
  table:put all-stimuli-table "16" "P" 
  table:put all-stimuli-table "17" "Q" 
  table:put all-stimuli-table "18" "R" 
  table:put all-stimuli-table "19" "S" 
  table:put all-stimuli-table "20" "T" 
  table:put all-stimuli-table "21" "U" 
  table:put all-stimuli-table "22" "V"  
  table:put all-stimuli-table "23" "W"  
  table:put all-stimuli-table "24" "X"  
  table:put all-stimuli-table "25" "Y"
  table:put all-stimuli-table "26" "Z"   
  set consonant-table table:make
  table:put consonant-table "B" "1"
  table:put consonant-table "C" "2"
  table:put consonant-table "D" "3"
  table:put consonant-table "F" "4"
  table:put consonant-table "G" "5"
  table:put consonant-table "H" "6"
  table:put consonant-table "J" "7"
  table:put consonant-table "K" "8"
  table:put consonant-table "L" "9"
  table:put consonant-table "M" "1"
  table:put consonant-table "N" "2"
  table:put consonant-table "P" "3"
  table:put consonant-table "Q" "4"
  table:put consonant-table "R" "5"
  table:put consonant-table "S" "6"
  table:put consonant-table "T" "7"
  table:put consonant-table "V"  "8"
  table:put consonant-table "W"  "9"
  table:put consonant-table "X"  "1"
  table:put consonant-table "Y" "2"
  table:put consonant-table "Z" "3"  
  set vowel-table table:make
  table:put vowel-table "A" "1"
  table:put vowel-table "E" "1"
  table:put vowel-table "I" "1"
  table:put vowel-table "O" "1"
  table:put vowel-table "U" "1"
end

to write-c-values 
  let t-word "_"
  set t-word word file-name-prefix t-word
  set t-word word t-word ticks
  let file-name word t-word "_stimuli-test.csv"
  file-open file-name
  file-write "breed, who, A, E, I, O, U, B1, B2, B3, B4, C1, C2, C3, C4, D1, D2, D3, D4, F1, F2, F3, F4, G1, G2, G3, G4, H1, H2, H3, H4, J1, J2, J3, J4, K1, K2, K3, K4, L1, L2, L3, L4,"
  file-write "M1, M2, M3, M4, N1, N2, N3, N4, P1, P2, P3, P4, Q1, Q2, Q3, Q4, R1, R2, R3, R4, S1, S2, S3, S4, T1, T2, T3, T4, V1, V2, V3, V4, W1, W2, W3, W4, X1, X2, X3, X4, Y1, Y2, Y3, Y4, Z1, Z2, Z3, Z4"
  file-write ",1!,1#,1$,1%,1&,1@,11,12,13,14,2!,2#,2$,2%,2&,2@,21,22,23,24, 3!,3#,3$,3%,3&,3@,31,32,33,34,4!,4#,4$,4%,4&,4@,41,42,43,44"
  file-print ""
  
    let output-table table:make
    table:put output-table "A" "0"
    table:put output-table "E" "0"
    table:put output-table "I" "0"
    table:put output-table "O" "0"
    table:put output-table "U" "0"
    table:put output-table "B1" "0"
    table:put output-table "B2" "0"
    table:put output-table "B3" "0"
    table:put output-table "B4" "0"
    table:put output-table "C1" "0"
    table:put output-table "C2" "0"
    table:put output-table "C3" "0"
    table:put output-table "C4" "0"
    table:put output-table "D1" "0"
    table:put output-table "D2" "0"
    table:put output-table "D3" "0"
    table:put output-table "D4" "0"
    table:put output-table "F1" "0"
    table:put output-table "F2" "0"
    table:put output-table "F3" "0"
    table:put output-table "F4" "0"
    table:put output-table "G1" "0"
    table:put output-table "G2" "0"
    table:put output-table "G3" "0"
    table:put output-table "G4" "0"
    table:put output-table "H1" "0"
    table:put output-table "H2" "0"
    table:put output-table "H3" "0"
    table:put output-table "H4" "0"
    table:put output-table "J1" "0"
    table:put output-table "J2" "0"
    table:put output-table "J3" "0"
    table:put output-table "J4" "0"
    table:put output-table "K1" "0"
    table:put output-table "K2" "0"
    table:put output-table "K3" "0"
    table:put output-table "K4" "0"
    table:put output-table "L1" "0"
    table:put output-table "L2" "0"
    table:put output-table "L3" "0"
    table:put output-table "L4" "0"
    table:put output-table "M1" "0"
    table:put output-table "M2" "0"
    table:put output-table "M3" "0"
    table:put output-table "M4" "0"
    table:put output-table "N1" "0"
    table:put output-table "N2" "0"
    table:put output-table "N3" "0"
    table:put output-table "N4" "0"
    table:put output-table "P1" "0"
    table:put output-table "P2" "0"
    table:put output-table "P3" "0"
    table:put output-table "P4" "0"
    table:put output-table "Q1" "0"
    table:put output-table "Q2" "0"
    table:put output-table "Q3" "0"
    table:put output-table "Q4" "0"
    table:put output-table "R1" "0"
    table:put output-table "R2" "0"
    table:put output-table "R3" "0"
    table:put output-table "R4" "0"
    table:put output-table "S1" "0"
    table:put output-table "S2" "0"
    table:put output-table "S3" "0"
    table:put output-table "S4" "0"
    table:put output-table "T1" "0"
    table:put output-table "T2" "0"
    table:put output-table "T3" "0"
    table:put output-table "T4" "0"
    table:put output-table "V1" "0"
    table:put output-table "V2" "0"
    table:put output-table "V3" "0"
    table:put output-table "V4" "0"
    table:put output-table "W1" "0"
    table:put output-table "W2" "0"
    table:put output-table "W3" "0"
    table:put output-table "W4" "0"
    table:put output-table "X1" "0"
    table:put output-table "X2" "0"
    table:put output-table "X3" "0"
    table:put output-table "X4" "0"
    table:put output-table "Y1" "0"
    table:put output-table "Y2" "0"
    table:put output-table "Y3" "0"
    table:put output-table "Y4" "0"
    table:put output-table "Z1" "0"
    table:put output-table "Z2" "0"
    table:put output-table "Z3" "0"
    table:put output-table "Z4" "0"
    table:put output-table "1!" "0"    
    table:put output-table "1#" "0"
    table:put output-table "1$" "0"
    table:put output-table "1%" "0"
    table:put output-table "1@" "0"
    table:put output-table "1&" "0"
    table:put output-table "11" "0"
    table:put output-table "12" "0"
    table:put output-table "13" "0"
    table:put output-table "14" "0"
    table:put output-table "2!" "0"    
    table:put output-table "2#" "0"
    table:put output-table "2$" "0"
    table:put output-table "2%" "0"
    table:put output-table "2@" "0"
    table:put output-table "2&" "0"
    table:put output-table "21" "0"
    table:put output-table "22" "0"
    table:put output-table "23" "0"
    table:put output-table "24" "0"
    table:put output-table "3!" "0"    
    table:put output-table "3#" "0"
    table:put output-table "3$" "0"
    table:put output-table "3%" "0"
    table:put output-table "3@" "0"
    table:put output-table "3&" "0"
    table:put output-table "31" "0"
    table:put output-table "32" "0"
    table:put output-table "33" "0"
    table:put output-table "34" "0"
    table:put output-table "4!" "0"    
    table:put output-table "4#" "0"
    table:put output-table "4$" "0"
    table:put output-table "4%" "0"
    table:put output-table "4@" "0"
    table:put output-table "4&" "0"
    table:put output-table "41" "0"
    table:put output-table "42" "0"
    table:put output-table "43" "0"
    table:put output-table "44" "0"

  ;;ask turtles [ file-show stimuli-table ]
  ask turtles [ 
    let table-to-output table:make 
    set table-to-output output-table
    let complete-row (word breed)
    let comma ","
    set complete-row word complete-row comma
    set complete-row word complete-row who
    set complete-row word complete-row comma
    let stimuli-keys table:keys stimuli-table
    let list-number 0
    while [list-number < length stimuli-keys] [
      let this-letter item list-number stimuli-keys
      set this-letter (word this-letter)
      ifelse table:has-key? table-to-output this-letter [ 
        table:put table-to-output this-letter 1
      ][
        let number-to-append table:get stimuli-table this-letter
        let new-key word this-letter number-to-append
        if table:has-key? table-to-output new-key [
        table:put table-to-output new-key 1
        ]
      ]   
      set list-number list-number + 1   
    ]

    set stimuli-keys table:keys table-to-output
    set list-number 0
    while [list-number < length stimuli-keys] [
      let this-letter item list-number stimuli-keys
      set this-letter (word this-letter)
      let value table:get table-to-output this-letter
      set complete-row word complete-row value
      set complete-row word complete-row comma
      set list-number list-number + 1  
    ]
    file-print complete-row
    table:put output-table "A" "0"
    table:put output-table "E" "0"
    table:put output-table "I" "0"
    table:put output-table "O" "0"
    table:put output-table "U" "0"
    table:put output-table "B1" "0"
    table:put output-table "B2" "0"
    table:put output-table "B3" "0"
    table:put output-table "B4" "0"
    table:put output-table "C1" "0"
    table:put output-table "C2" "0"
    table:put output-table "C3" "0"
    table:put output-table "C4" "0"
    table:put output-table "D1" "0"
    table:put output-table "D2" "0"
    table:put output-table "D3" "0"
    table:put output-table "D4" "0"
    table:put output-table "F1" "0"
    table:put output-table "F2" "0"
    table:put output-table "F3" "0"
    table:put output-table "F4" "0"
    table:put output-table "G1" "0"
    table:put output-table "G2" "0"
    table:put output-table "G3" "0"
    table:put output-table "G4" "0"
    table:put output-table "H1" "0"
    table:put output-table "H2" "0"
    table:put output-table "H3" "0"
    table:put output-table "H4" "0"
    table:put output-table "J1" "0"
    table:put output-table "J2" "0"
    table:put output-table "J3" "0"
    table:put output-table "J4" "0"
    table:put output-table "K1" "0"
    table:put output-table "K2" "0"
    table:put output-table "K3" "0"
    table:put output-table "K4" "0"
    table:put output-table "L1" "0"
    table:put output-table "L2" "0"
    table:put output-table "L3" "0"
    table:put output-table "L4" "0"
    table:put output-table "M1" "0"
    table:put output-table "M2" "0"
    table:put output-table "M3" "0"
    table:put output-table "M4" "0"
    table:put output-table "N1" "0"
    table:put output-table "N2" "0"
    table:put output-table "N3" "0"
    table:put output-table "N4" "0"
    table:put output-table "P1" "0"
    table:put output-table "P2" "0"
    table:put output-table "P3" "0"
    table:put output-table "P4" "0"
    table:put output-table "Q1" "0"
    table:put output-table "Q2" "0"
    table:put output-table "Q3" "0"
    table:put output-table "Q4" "0"
    table:put output-table "R1" "0"
    table:put output-table "R2" "0"
    table:put output-table "R3" "0"
    table:put output-table "R4" "0"
    table:put output-table "S1" "0"
    table:put output-table "S2" "0"
    table:put output-table "S3" "0"
    table:put output-table "S4" "0"
    table:put output-table "T1" "0"
    table:put output-table "T2" "0"
    table:put output-table "T3" "0"
    table:put output-table "T4" "0"
    table:put output-table "V1" "0"
    table:put output-table "V2" "0"
    table:put output-table "V3" "0"
    table:put output-table "V4" "0"
    table:put output-table "W1" "0"
    table:put output-table "W2" "0"
    table:put output-table "W3" "0"
    table:put output-table "W4" "0"
    table:put output-table "X1" "0"
    table:put output-table "X2" "0"
    table:put output-table "X3" "0"
    table:put output-table "X4" "0"
    table:put output-table "Y1" "0"
    table:put output-table "Y2" "0"
    table:put output-table "Y3" "0"
    table:put output-table "Y4" "0"
    table:put output-table "Z1" "0"
    table:put output-table "Z2" "0"
    table:put output-table "Z3" "0"
    table:put output-table "Z4" "0"
    table:put output-table "1!" "0"    
    table:put output-table "1#" "0"
    table:put output-table "1$" "0"
    table:put output-table "1%" "0"
    table:put output-table "1@" "0"
    table:put output-table "1&" "0"
    table:put output-table "11" "0"
    table:put output-table "12" "0"
    table:put output-table "13" "0"
    table:put output-table "14" "0"
    table:put output-table "2!" "0"    
    table:put output-table "2#" "0"
    table:put output-table "2$" "0"
    table:put output-table "2%" "0"
    table:put output-table "2@" "0"
    table:put output-table "2&" "0"
    table:put output-table "21" "0"
    table:put output-table "22" "0"
    table:put output-table "23" "0"
    table:put output-table "24" "0"
    table:put output-table "3!" "0"    
    table:put output-table "3#" "0"
    table:put output-table "3$" "0"
    table:put output-table "3%" "0"
    table:put output-table "3@" "0"
    table:put output-table "3&" "0"
    table:put output-table "31" "0"
    table:put output-table "32" "0"
    table:put output-table "33" "0"
    table:put output-table "34" "0"
    table:put output-table "4!" "0"    
    table:put output-table "4#" "0"
    table:put output-table "4$" "0"
    table:put output-table "4%" "0"
    table:put output-table "4@" "0"
    table:put output-table "4&" "0"
    table:put output-table "41" "0"
    table:put output-table "42" "0"
    table:put output-table "43" "0"
    table:put output-table "44" "0"
    ]
  file-close
end









@#$#@#$#@
GRAPHICS-WINDOW
243
10
999
539
90
60
4.122
1
10
1
1
1
0
1
1
1
-90
90
-60
60
1
1
1
ticks

BUTTON
9
10
75
43
Setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
83
10
146
43
Go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
6
47
178
80
initial-saxons
initial-saxons
0
100
25
1
1
NIL
HORIZONTAL

SLIDER
6
79
178
112
initial-britains
initial-britains
0
100
25
1
1
NIL
HORIZONTAL

SLIDER
6
185
178
218
vision
vision
0
20
8
1
1
NIL
HORIZONTAL

SLIDER
6
110
178
143
initial-norse
initial-norse
0
100
25
1
1
NIL
HORIZONTAL

SLIDER
4
254
229
287
number-of-outside-family-links
number-of-outside-family-links
0
25
3
1
1
NIL
HORIZONTAL

SLIDER
4
222
229
255
number-of-outside-political-links
number-of-outside-political-links
0
25
3
1
1
NIL
HORIZONTAL

SLIDER
4
286
229
319
scir-leader-influence
scir-leader-influence
0
100
50
1
1
NIL
HORIZONTAL

SLIDER
5
319
229
352
mearc-leader-influence
mearc-leader-influence
0
100
50
1
1
NIL
HORIZONTAL

SLIDER
6
351
229
384
capital-value-for-political-link
capital-value-for-political-link
0
100
80
1
1
NIL
HORIZONTAL

SLIDER
3
409
175
442
birth-chance
birth-chance
0
100
10
1
1
NIL
HORIZONTAL

SLIDER
3
441
175
474
death-chance
death-chance
0
100
10
1
1
NIL
HORIZONTAL

TEXTBOX
24
391
174
409
Agent must be over 30
11
0.0
1

SLIDER
6
144
179
177
initial-irish
initial-irish
0
100
25
1
1
NIL
HORIZONTAL

SWITCH
6
482
131
515
hide-links
hide-links
0
1
-1000

SWITCH
6
514
188
547
show-agent-density
show-agent-density
1
1
-1000

SLIDER
6
581
178
614
migration-chance
migration-chance
0
100
15
1
1
NIL
HORIZONTAL

SWITCH
6
548
153
581
S-N-migration
S-N-migration
1
1
-1000

SWITCH
6
614
137
647
elite-migration
elite-migration
1
1
-1000

TEXTBOX
145
618
326
660
Uses capital-value-for-political link to determine elites
11
0.0
1

SWITCH
8
657
226
690
save-concordance-values
save-concordance-values
0
1
-1000

CHOOSER
232
649
395
694
every-X-num-of-ticks
every-X-num-of-ticks
"1" "2" "3" "4" "5" "10" "15" "20" "25" "50"
8

SWITCH
153
548
315
581
global-migration
global-migration
1
1
-1000

TEXTBOX
197
567
347
585
(non-directional)
11
0.0
1

SLIDER
7
695
179
728
file-name-prefix
file-name-prefix
0
1000
1
1
1
NIL
HORIZONTAL

@#$#@#$#@
WHAT IS IT?
-----------
The purpose of this model is to explore how culture contact motivates people to make changes to their material culture. Our model employs Pierre Bourdieus frameworks and insights upon social organization to simulate the impact of culture contact upon four different but related social groups. We use our model to provide insight into the Anglo-Saxon migration to England in the fifth and sixth centuries AD.


HOW IT WORKS
------------
In general, the model process centers on the movement of agents to agents that share similar behavioral stimuli. First, agents access if they should create a descendant. Once new agents have been created they evaluate how similar they are to the agents around them. If the closest match within their mearc, isnt within their neighborhood, then they move towards the agent they have the most in common with. Once they are comfortable with the agents nearby, within their neighborhood, they then interact with those agents and share behavioral stimuli. The direction and type of sharing is based upon each agents capital and the disparity between their capitals. 

If no similar agents can be found within a mearc, then agents look for similar agents within the family. Family links are created randomly at the onset of the simulation. If no similar family can be found, civic connections are examined. Civic connections are agents who have moved to other mearcs from an agents current mearc. If civic connections do not yield a similar agent, all agents of the same breed type (e.g. ethnic groups) are examined. If no similar agents are found, political links are examined and if no one is similar enough, agents move to a random spot in the simulation and interact with their neighbor. Once an agent decides upon whom of the aforementioned groups, they will interact with, they move to that agent. This may result in local mearc movement, movement to a different mearc within the same scir, or migration to entirely different scirs.

Several sub-models are enacted after the main model sequence in order to test several types of migration depending on the model initialization settings (what types of migration are turned on).  Elite migration gives each elite a user chosen chance of movement from a bottom scir to a top scir. Global migration gives each agent a random chance of movement from their mearc to a different one. South to North global migration gives each agent a chance to move from mearcs on the bottom of the model to mearcs on the top.




CREDITS AND REFERENCES
----------------------

Roberts, Chris and Sean M. Bergin. (2011) Complex objects, entangled lives: using Germanic animal art as a record of culture contact in early medieval England. Paper presented at the 76th Annual Meeting of the Society for American Archaeology, Sacramento, CA.

http://www.openabm.org/model-archive/simm_bourdieu
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -7500403 true true 151 225 180 285
Rectangle -7500403 true true 47 225 75 285
Rectangle -7500403 true true 15 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 165 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.1.2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="experiment-base" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="500"/>
    <exitCondition>count turtles = 0</exitCondition>
    <metric>count turtles</metric>
    <enumeratedValueSet variable="initial-saxons">
      <value value="25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-of-outside-family-links">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initial-irish">
      <value value="25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="hide-links">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-of-outside-political-links">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="capital-value-for-political-link">
      <value value="80"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="global-migration">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="elite-migration">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="every-X-num-of-ticks">
      <value value="&quot;25&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-chance">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-agent-density">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initial-britains">
      <value value="25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="vision">
      <value value="8"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initial-norse">
      <value value="25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mearc-leader-influence">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="death-chance">
      <value value="10"/>
    </enumeratedValueSet>
    <steppedValueSet variable="file-name-prefix" first="1" step="1" last="10"/>
    <enumeratedValueSet variable="save-concordance-values">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="S-N-migration">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="migration-chance">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="scir-leader-influence">
      <value value="50"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
